<template>
  <a-page-header :title="getPageTitle()" @back="() => $router.go(-1)">
    <template #extra>
      <Extra/>
    </template>
    <a-card :bordered="false" :body-style="{ padding: '16px' }">
      <ele-pro-table
        ref="tableRef"
        row-key="appRenewId"
        :columns="columns"
        :datasource="datasource"
        :customRow="customRow"
        tool-class="ele-toolbar-form"
        class="sys-org-table"
      >
        <template #toolbar>
          <search
            @search="reload"
            :selection="selection"
            @add="openEdit"
            @remove="removeBatch"
            @batchMove="openMove"
          />
        </template>
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'appName'">
            <span class="cursor-pointer" @click="onSearch(record)">{{ record.appName }}</span>
          </template>
          <template v-if="column.key === 'appIcon'">
            <a-avatar :src="record.appIcon" :size="40"/>
          </template>
          <template v-if="column.key === 'images'">
            <a-image v-if="record.images && JSON.parse(record.images).length > 0" style="width: 50px;" :src="JSON.parse(record.images)[0].url"/>
          </template>
          <template v-if="column.key === 'duration'">
            <span v-if="record.days">{{ record.days }}天</span>
            <span v-else>{{ record.duration }}年</span>
          </template>
          <template v-if="column.key === 'customerName'">
            <a-tooltip :title="`客户ID(${record.customerId})`">
              {{ record.customerName }}
            </a-tooltip>
          </template>
          <template v-if="column.key === 'endTime'">
            <div>续费前：{{ toDateString(record.startTime, 'yyyy-MM-dd') }}</div>
            <div>续费后：{{ toDateString(record.endTime, 'yyyy-MM-dd') }}</div>
          </template>
          <template v-if="column.key === 'status'">
            <a-tag color="green" v-if="record.status === 1">已入账</a-tag>
            <a-tag color="orange" v-if="record.status === 0">待审核</a-tag>
          </template>
          <template v-if="column.key === 'action'">
            <a-space v-if="hasRole('superAdmin') || hasRole('admin')">
              <a-popconfirm
                title="确定要撤销续费操作吗？"
                @confirm="remove(record)"
              >
                <a-button size="small">取消订单</a-button>
              </a-popconfirm>
            </a-space>
          </template>
        </template>
      </ele-pro-table>
    </a-card>

    <!-- 编辑弹窗 -->
    <ProjectRenewEdit v-model:visible="showEdit" :data="current" @done="reload"/>
  </a-page-header>
</template>

<script lang="ts" setup>
import { ref, unref, watch, createVNode } from 'vue';
import {message, Modal} from 'ant-design-vue';
import { useRouter } from 'vue-router';
import {ExclamationCircleOutlined} from '@ant-design/icons-vue';
import type {EleProTable} from 'ele-admin-pro';
import {toDateString} from 'ele-admin-pro';
import type {
  DatasourceFunction,
  ColumnItem
} from 'ele-admin-pro/es/ele-pro-table/types';
import Search from './components/search.vue';
import ProjectRenewEdit from './components/projectRenewEdit.vue';
import {pageProjectRenew, removeProjectRenew, removeBatchProjectRenew} from '@/api/project/projectRenew';
import type {ProjectRenew, ProjectRenewParam} from '@/api/project/projectRenew/model';
import {getPageTitle} from "@/utils/common";
import Extra from "@/views/project/project/components/extra.vue";
import {hasRole} from "@/utils/permission";

// 表格实例
const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

// 表格选中数据
const selection = ref<ProjectRenew[]>([]);
// 当前编辑数据
const current = ref<ProjectRenew | null>(null);
// 是否显示编辑弹窗
const showEdit = ref(false);
// 是否显示批量移动弹窗
const showMove = ref(false);
// 加载状态
const loading = ref(true);
const appId = ref<number>();
const { currentRoute } = useRouter();

// 表格数据源
const datasource: DatasourceFunction = ({
                                          page,
                                          limit,
                                          where,
                                          orders
                                        }) => {
  where.sort = 'appRenewId';
  where.order = 'desc';
  if(appId.value){
    where.appId = appId.value;
  }
  return pageProjectRenew({
    ...where,
    ...orders,
    page,
    limit
  });
};

// 表格列配置
const columns = ref<ColumnItem[]>([
  {
    title: '订单编号',
    dataIndex: 'appRenewId',
    key: 'appRenewId'
  },
  {
    title: '项目名称',
    dataIndex: 'appName',
    key: 'appName'
  },
  {
    title: '续费金额',
    dataIndex: 'payPrice',
    key: 'payPrice',
    sorter: true,
    customRender: ({text}) => `￥${text}`
  },
  {
    title: '续费时长',
    dataIndex: 'duration',
    key: 'duration',
    sorter: true,
    align: 'center'
  },
  {
    title: '到期时间',
    dataIndex: 'endTime',
    key: 'endTime',
    sorter: true,
    align: 'center',
    customRender: ({text}) => toDateString(text, 'yyyy-MM-dd HH:mm')
  },
  // {
  //   title: '客户名称',
  //   dataIndex: 'customerName',
  //   key: 'customerName',
  //   align: 'center',
  // },
  // {
  //   title: '状态',
  //   dataIndex: 'status',
  //   key: 'status',
  //   align: 'center'
  // },
  {
    title: '操作员',
    dataIndex: 'nickname',
    key: 'nickname',
    align: 'center',
  },
  {
    title: '备注',
    dataIndex: 'comments',
    key: 'comments',
    align: 'center',
  },
  {
    title: '付款凭证',
    dataIndex: 'images',
    key: 'images',
    align: 'center',
  },
  {
    title: '创建时间',
    dataIndex: 'createTime',
    key: 'createTime',
    sorter: true,
    align: 'center',
    customRender: ({text}) => toDateString(text, 'yyyy-MM-dd HH:mm:ss')
  },
  {
    title: '操作',
    key: 'action',
    width: 180,
    fixed: 'right',
    align: 'center',
    hideInSetting: true
  }
]);

/* 搜索 */
const reload = (where?: ProjectRenewParam) => {
  selection.value = [];
  tableRef?.value?.reload({where: where});
};

/* 打开编辑弹窗 */
const openEdit = (row?: ProjectRenew) => {
  current.value = row ?? null;
  showEdit.value = true;
};

/* 打开批量移动弹窗 */
const openMove = () => {
  showMove.value = true;
};

const onSearch = (row: ProjectRenew) => {
  reload({appId: row?.appId})
}

/* 删除单个 */
const remove = (row: ProjectRenew) => {
  const hide = message.loading('请求中..', 0);
  removeProjectRenew(row.appRenewId)
    .then((msg) => {
      hide();
      message.success(msg);
      reload();
    })
    .catch((e) => {
      hide();
      message.error(e.message);
    });
};

/* 批量删除 */
const removeBatch = () => {
  if (!selection.value.length) {
    message.error('请至少选择一条数据');
    return;
  }
  Modal.confirm({
    title: '提示',
    content: '确定要删除选中的记录吗?',
    icon: createVNode(ExclamationCircleOutlined),
    maskClosable: true,
    onOk: () => {
      const hide = message.loading('请求中..', 0);
      removeBatchProjectRenew(selection.value.map((d) => d.appRenewId))
        .then((msg) => {
          hide();
          message.success(msg);
          reload();
        })
        .catch((e) => {
          hide();
          message.error(e.message);
        });
    }
  });
};

/* 查询 */
const query = () => {
  loading.value = true;
};

/* 自定义行属性 */
const customRow = (record: ProjectRenew) => {
  return {
    // 行点击事件
    onClick: () => {
      // console.log(record);
    },
    // 行双击事件
    onDblclick: () => {
      if (hasRole('superAdmin')) {
        openEdit(record);
      }
    }
  };
};
query();

watch(
  currentRoute,
  (route) => {
    const { params } = unref(route);
    const { id } = params;
    if (id) {
      appId.value = Number(id);
      reload()
    }
    reload();
  },
  { immediate: true }
);
</script>

<script lang="ts">
export default {
  name: 'ProjectRenew'
};
</script>

<style lang="less" scoped></style>
